/* gitg-dirs.c generated by valac 0.46.1, the Vala compiler
 * generated from gitg-dirs.vala, do not modify */

/*
 * This file is part of gitg
 *
 * Copyright (C) 2012 - Jesse van den Kieboom
 *
 * gitg is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * gitg is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with gitg. If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <stdarg.h>
#include "libgitg/gitg-platform-support.h"
#include <gobject/gvaluecollector.h>

#define GITG_TYPE_DIRS (gitg_dirs_get_type ())
#define GITG_DIRS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GITG_TYPE_DIRS, GitgDirs))
#define GITG_DIRS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GITG_TYPE_DIRS, GitgDirsClass))
#define GITG_IS_DIRS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GITG_TYPE_DIRS))
#define GITG_IS_DIRS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GITG_TYPE_DIRS))
#define GITG_DIRS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GITG_TYPE_DIRS, GitgDirsClass))

typedef struct _GitgDirs GitgDirs;
typedef struct _GitgDirsClass GitgDirsClass;
typedef struct _GitgDirsPrivate GitgDirsPrivate;
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _GitgParamSpecDirs GitgParamSpecDirs;

struct _GitgDirs {
	GTypeInstance parent_instance;
	volatile int ref_count;
	GitgDirsPrivate * priv;
};

struct _GitgDirsClass {
	GTypeClass parent_class;
	void (*finalize) (GitgDirs *self);
};

struct _GitgParamSpecDirs {
	GParamSpec parent_instance;
};

static gpointer gitg_dirs_parent_class = NULL;

gpointer gitg_dirs_ref (gpointer instance);
void gitg_dirs_unref (gpointer instance);
GParamSpec* gitg_param_spec_dirs (const gchar* name,
                                  const gchar* nick,
                                  const gchar* blurb,
                                  GType object_type,
                                  GParamFlags flags);
void gitg_value_set_dirs (GValue* value,
                          gpointer v_object);
void gitg_value_take_dirs (GValue* value,
                           gpointer v_object);
gpointer gitg_value_get_dirs (const GValue* value);
GType gitg_dirs_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GitgDirs, gitg_dirs_unref)
gchar* gitg_dirs_build_data_file (const gchar* part,
                                  ...);
gchar* gitg_dirs_get_data_dir (void);
GitgDirs* gitg_dirs_new (void);
GitgDirs* gitg_dirs_construct (GType object_type);
gchar* gitg_dirs_get_locale_dir (void);
gchar* gitg_dirs_get_lib_dir (void);
gchar* gitg_dirs_get_plugins_dir (void);
gchar* gitg_dirs_get_plugins_data_dir (void);
gchar* gitg_dirs_get_user_plugins_dir (void);
gchar* gitg_dirs_get_user_data_dir (void);
gchar* gitg_dirs_get_user_plugins_data_dir (void);
static void gitg_dirs_finalize (GitgDirs * obj);

gchar*
gitg_dirs_build_data_file (const gchar* part,
                           ...)
{
	va_list l = {0};
	gchar* ret = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* result = NULL;
	g_return_val_if_fail (part != NULL, NULL);
	va_start (l, part);
	_tmp0_ = gitg_dirs_get_data_dir ();
	_tmp1_ = _tmp0_;
	_tmp2_ = _tmp1_;
	_tmp3_ = g_build_filename (_tmp2_, part, NULL, NULL);
	_tmp4_ = _tmp3_;
	_g_free0 (_tmp2_);
	ret = _tmp4_;
	while (TRUE) {
		gchar* s = NULL;
		const gchar* _tmp5_;
		gchar* _tmp6_;
		const gchar* _tmp7_;
		const gchar* _tmp8_;
		const gchar* _tmp9_;
		gchar* _tmp10_;
		_tmp5_ = va_arg (l, gchar*);
		_tmp6_ = g_strdup (_tmp5_);
		s = _tmp6_;
		_tmp7_ = s;
		if (_tmp7_ == NULL) {
			_g_free0 (s);
			break;
		}
		_tmp8_ = ret;
		_tmp9_ = s;
		_tmp10_ = g_build_filename (_tmp8_, _tmp9_, NULL);
		_g_free0 (ret);
		ret = _tmp10_;
		_g_free0 (s);
	}
	result = ret;
	va_end (l);
	return result;
}

GitgDirs*
gitg_dirs_construct (GType object_type)
{
	GitgDirs* self = NULL;
	self = (GitgDirs*) g_type_create_instance (object_type);
	return self;
}

GitgDirs*
gitg_dirs_new (void)
{
	return gitg_dirs_construct (GITG_TYPE_DIRS);
}

gchar*
gitg_dirs_get_data_dir (void)
{
	gchar* result;
	gchar* _tmp0_;
	_tmp0_ = gitg_platform_support_get_data_dir ();
	result = _tmp0_;
	return result;
}

gchar*
gitg_dirs_get_locale_dir (void)
{
	gchar* result;
	gchar* _tmp0_;
	_tmp0_ = gitg_platform_support_get_locale_dir ();
	result = _tmp0_;
	return result;
}

gchar*
gitg_dirs_get_lib_dir (void)
{
	gchar* result;
	gchar* _tmp0_;
	_tmp0_ = gitg_platform_support_get_lib_dir ();
	result = _tmp0_;
	return result;
}

gchar*
gitg_dirs_get_plugins_dir (void)
{
	gchar* result;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	_tmp0_ = gitg_dirs_get_lib_dir ();
	_tmp1_ = _tmp0_;
	_tmp2_ = _tmp1_;
	_tmp3_ = g_build_filename (_tmp2_, "plugins", NULL);
	_tmp4_ = _tmp3_;
	_g_free0 (_tmp2_);
	result = _tmp4_;
	return result;
}

gchar*
gitg_dirs_get_plugins_data_dir (void)
{
	gchar* result;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	_tmp0_ = gitg_dirs_get_data_dir ();
	_tmp1_ = _tmp0_;
	_tmp2_ = _tmp1_;
	_tmp3_ = g_build_filename (_tmp2_, "plugins", NULL);
	_tmp4_ = _tmp3_;
	_g_free0 (_tmp2_);
	result = _tmp4_;
	return result;
}

gchar*
gitg_dirs_get_user_plugins_dir (void)
{
	gchar* result;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	_tmp0_ = gitg_dirs_get_user_data_dir ();
	_tmp1_ = _tmp0_;
	_tmp2_ = _tmp1_;
	_tmp3_ = g_build_filename (_tmp2_, "plugins", NULL);
	_tmp4_ = _tmp3_;
	_g_free0 (_tmp2_);
	result = _tmp4_;
	return result;
}

gchar*
gitg_dirs_get_user_plugins_data_dir (void)
{
	gchar* result;
	gchar* _tmp0_;
	gchar* _tmp1_;
	_tmp0_ = gitg_dirs_get_user_plugins_dir ();
	_tmp1_ = _tmp0_;
	result = _tmp1_;
	return result;
}

gchar*
gitg_dirs_get_user_data_dir (void)
{
	gchar* result;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	_tmp0_ = g_get_user_data_dir ();
	_tmp1_ = g_build_filename (_tmp0_, "gitg", NULL);
	result = _tmp1_;
	return result;
}

static void
gitg_value_dirs_init (GValue* value)
{
	value->data[0].v_pointer = NULL;
}

static void
gitg_value_dirs_free_value (GValue* value)
{
	if (value->data[0].v_pointer) {
		gitg_dirs_unref (value->data[0].v_pointer);
	}
}

static void
gitg_value_dirs_copy_value (const GValue* src_value,
                            GValue* dest_value)
{
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = gitg_dirs_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}

static gpointer
gitg_value_dirs_peek_pointer (const GValue* value)
{
	return value->data[0].v_pointer;
}

static gchar*
gitg_value_dirs_collect_value (GValue* value,
                               guint n_collect_values,
                               GTypeCValue* collect_values,
                               guint collect_flags)
{
	if (collect_values[0].v_pointer) {
		GitgDirs * object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = gitg_dirs_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}

static gchar*
gitg_value_dirs_lcopy_value (const GValue* value,
                             guint n_collect_values,
                             GTypeCValue* collect_values,
                             guint collect_flags)
{
	GitgDirs ** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = gitg_dirs_ref (value->data[0].v_pointer);
	}
	return NULL;
}

GParamSpec*
gitg_param_spec_dirs (const gchar* name,
                      const gchar* nick,
                      const gchar* blurb,
                      GType object_type,
                      GParamFlags flags)
{
	GitgParamSpecDirs* spec;
	g_return_val_if_fail (g_type_is_a (object_type, GITG_TYPE_DIRS), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}

gpointer
gitg_value_get_dirs (const GValue* value)
{
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GITG_TYPE_DIRS), NULL);
	return value->data[0].v_pointer;
}

void
gitg_value_set_dirs (GValue* value,
                     gpointer v_object)
{
	GitgDirs * old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GITG_TYPE_DIRS));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, GITG_TYPE_DIRS));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		gitg_dirs_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		gitg_dirs_unref (old);
	}
}

void
gitg_value_take_dirs (GValue* value,
                      gpointer v_object)
{
	GitgDirs * old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GITG_TYPE_DIRS));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, GITG_TYPE_DIRS));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		gitg_dirs_unref (old);
	}
}

static void
gitg_dirs_class_init (GitgDirsClass * klass,
                      gpointer klass_data)
{
	gitg_dirs_parent_class = g_type_class_peek_parent (klass);
	((GitgDirsClass *) klass)->finalize = gitg_dirs_finalize;
}

static void
gitg_dirs_instance_init (GitgDirs * self,
                         gpointer klass)
{
	self->ref_count = 1;
}

static void
gitg_dirs_finalize (GitgDirs * obj)
{
	GitgDirs * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GITG_TYPE_DIRS, GitgDirs);
	g_signal_handlers_destroy (self);
}

GType
gitg_dirs_get_type (void)
{
	static volatile gsize gitg_dirs_type_id__volatile = 0;
	if (g_once_init_enter (&gitg_dirs_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { gitg_value_dirs_init, gitg_value_dirs_free_value, gitg_value_dirs_copy_value, gitg_value_dirs_peek_pointer, "p", gitg_value_dirs_collect_value, "p", gitg_value_dirs_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (GitgDirsClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gitg_dirs_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GitgDirs), 0, (GInstanceInitFunc) gitg_dirs_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType gitg_dirs_type_id;
		gitg_dirs_type_id = g_type_register_fundamental (g_type_fundamental_next (), "GitgDirs", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&gitg_dirs_type_id__volatile, gitg_dirs_type_id);
	}
	return gitg_dirs_type_id__volatile;
}

gpointer
gitg_dirs_ref (gpointer instance)
{
	GitgDirs * self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}

void
gitg_dirs_unref (gpointer instance)
{
	GitgDirs * self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		GITG_DIRS_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}

