/* gitg-credentials-manager.c generated by valac 0.46.1, the Vala compiler
 * generated from gitg-credentials-manager.vala, do not modify */

/*
 * This file is part of gitg
 *
 * Copyright (C) 2014 - Jesse van den Kieboom
 *
 * gitg is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * gitg is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with gitg. If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include <libgit2-glib/ggit.h>
#include <gtk/gtk.h>
#include <gee.h>
#include <stdlib.h>
#include <string.h>
#include <libsecret/secret.h>
#include <stdio.h>
#include <gio/gio.h>
#include <libsoup/soup.h>
#include "config.h"
#include <gobject/gvaluecollector.h>

#define GITG_TYPE_CREDENTIALS_MANAGER (gitg_credentials_manager_get_type ())
#define GITG_CREDENTIALS_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GITG_TYPE_CREDENTIALS_MANAGER, GitgCredentialsManager))
#define GITG_CREDENTIALS_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GITG_TYPE_CREDENTIALS_MANAGER, GitgCredentialsManagerClass))
#define GITG_IS_CREDENTIALS_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GITG_TYPE_CREDENTIALS_MANAGER))
#define GITG_IS_CREDENTIALS_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GITG_TYPE_CREDENTIALS_MANAGER))
#define GITG_CREDENTIALS_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GITG_TYPE_CREDENTIALS_MANAGER, GitgCredentialsManagerClass))

typedef struct _GitgCredentialsManager GitgCredentialsManager;
typedef struct _GitgCredentialsManagerClass GitgCredentialsManagerClass;
typedef struct _GitgCredentialsManagerPrivate GitgCredentialsManagerPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef enum  {
	GITG_AUTHENTICATION_LIFE_TIME_FORGET,
	GITG_AUTHENTICATION_LIFE_TIME_SESSION,
	GITG_AUTHENTICATION_LIFE_TIME_FOREVER
} GitgAuthenticationLifeTime;

#define GITG_TYPE_AUTHENTICATION_LIFE_TIME (gitg_authentication_life_time_get_type ())
typedef struct _Block5Data Block5Data;
#define _gitg_credentials_manager_unref0(var) ((var == NULL) ? NULL : (var = (gitg_credentials_manager_unref (var), NULL)))

#define GITG_TYPE_AUTHENTICATION_DIALOG (gitg_authentication_dialog_get_type ())
#define GITG_AUTHENTICATION_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GITG_TYPE_AUTHENTICATION_DIALOG, GitgAuthenticationDialog))
#define GITG_AUTHENTICATION_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GITG_TYPE_AUTHENTICATION_DIALOG, GitgAuthenticationDialogClass))
#define GITG_IS_AUTHENTICATION_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GITG_TYPE_AUTHENTICATION_DIALOG))
#define GITG_IS_AUTHENTICATION_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GITG_TYPE_AUTHENTICATION_DIALOG))
#define GITG_AUTHENTICATION_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GITG_TYPE_AUTHENTICATION_DIALOG, GitgAuthenticationDialogClass))

typedef struct _GitgAuthenticationDialog GitgAuthenticationDialog;
typedef struct _GitgAuthenticationDialogClass GitgAuthenticationDialogClass;
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
#define _g_match_info_unref0(var) ((var == NULL) ? NULL : (var = (g_match_info_unref (var), NULL)))
#define __vala_SoupURI_free0(var) ((var == NULL) ? NULL : (var = (_vala_SoupURI_free (var), NULL)))
#define _secret_schema_unref0(var) ((var == NULL) ? NULL : (var = (secret_schema_unref (var), NULL)))
typedef struct _GitgParamSpecCredentialsManager GitgParamSpecCredentialsManager;

typedef enum  {
	GITG_CREDENTIALS_ERROR_CANCELLED
} GitgCredentialsError;
#define GITG_CREDENTIALS_ERROR gitg_credentials_error_quark ()
struct _GitgCredentialsManager {
	GTypeInstance parent_instance;
	volatile int ref_count;
	GitgCredentialsManagerPrivate * priv;
};

struct _GitgCredentialsManagerClass {
	GTypeClass parent_class;
	void (*finalize) (GitgCredentialsManager *self);
};

struct _GitgCredentialsManagerPrivate {
	GgitConfig* d_config;
	GtkWindow* d_window;
	GeeHashMap* d_usermap;
	gboolean d_save_user_in_config;
	gchar* d_last_user;
	GeeHashMap* d_auth_tried;
};

struct _Block5Data {
	int _ref_count_;
	GitgCredentialsManager* self;
	GMutex mutex;
	GCond cond;
	GtkResponseType response;
	gchar* password;
	gchar* newusername;
	GitgAuthenticationLifeTime lifetime;
	gchar* url;
	gchar* username;
};

struct _GitgParamSpecCredentialsManager {
	GParamSpec parent_instance;
};

static gint GitgCredentialsManager_private_offset;
static gpointer gitg_credentials_manager_parent_class = NULL;
static SecretSchema* gitg_credentials_manager_s_secret_schema;
static SecretSchema* gitg_credentials_manager_s_secret_schema = NULL;
static GRegex* gitg_credentials_manager_s_ssh_short_form;
static GRegex* gitg_credentials_manager_s_ssh_short_form = NULL;

GQuark gitg_credentials_error_quark (void);
gpointer gitg_credentials_manager_ref (gpointer instance);
void gitg_credentials_manager_unref (gpointer instance);
GParamSpec* gitg_param_spec_credentials_manager (const gchar* name,
                                                 const gchar* nick,
                                                 const gchar* blurb,
                                                 GType object_type,
                                                 GParamFlags flags);
void gitg_value_set_credentials_manager (GValue* value,
                                         gpointer v_object);
void gitg_value_take_credentials_manager (GValue* value,
                                          gpointer v_object);
gpointer gitg_value_get_credentials_manager (const GValue* value);
GType gitg_credentials_manager_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GitgCredentialsManager, gitg_credentials_manager_unref)
GitgCredentialsManager* gitg_credentials_manager_new (GgitConfig* config,
                                                      GtkWindow* window,
                                                      gboolean save_user_in_config);
GitgCredentialsManager* gitg_credentials_manager_construct (GType object_type,
                                                            GgitConfig* config,
                                                            GtkWindow* window,
                                                            gboolean save_user_in_config);
static gchar* gitg_credentials_manager_lookup_user (GitgCredentialsManager* self,
                                             const gchar* host);
static gint _____lambda39_ (GitgCredentialsManager* self,
                     GMatchInfo* info,
                     const gchar* value);
static gint ______lambda39__ggit_config_match_callback (GMatchInfo* match_info,
                                                 const gchar* value,
                                                 gpointer self);
static GgitCred* gitg_credentials_manager_user_pass_dialog (GitgCredentialsManager* self,
                                                     const gchar* url,
                                                     const gchar* scheme,
                                                     const gchar* host,
                                                     const gchar* username,
                                                     GError** error);
GType gitg_authentication_life_time_get_type (void) G_GNUC_CONST;
static Block5Data* block5_data_ref (Block5Data* _data5_);
static void block5_data_unref (void * _userdata_);
static gboolean __lambda40_ (Block5Data* _data5_);
GType gitg_authentication_dialog_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GitgAuthenticationDialog, g_object_unref)
GitgAuthenticationDialog* gitg_authentication_dialog_new (const gchar* url,
                                                          const gchar* username,
                                                          gboolean failed);
GitgAuthenticationDialog* gitg_authentication_dialog_construct (GType object_type,
                                                                const gchar* url,
                                                                const gchar* username,
                                                                gboolean failed);
const gchar* gitg_authentication_dialog_get_username (GitgAuthenticationDialog* self);
const gchar* gitg_authentication_dialog_get_password (GitgAuthenticationDialog* self);
GitgAuthenticationLifeTime gitg_authentication_dialog_get_life_time (GitgAuthenticationDialog* self);
static gboolean ___lambda40__gsource_func (gpointer self);
static void _g_free0_ (gpointer var);
static void ___lambda41_ (GitgCredentialsManager* self,
                   GObject* obj,
                   GAsyncResult* res);
static void ____lambda41__gasync_ready_callback (GObject* source_object,
                                          GAsyncResult* res,
                                          gpointer self);
static void ___lambda42_ (GitgCredentialsManager* self,
                   GObject* obj,
                   GAsyncResult* res);
static void ____lambda42__gasync_ready_callback (GObject* source_object,
                                          GAsyncResult* res,
                                          gpointer self);
static GgitCred* gitg_credentials_manager_query_user_pass (GitgCredentialsManager* self,
                                                    const gchar* url,
                                                    const gchar* username,
                                                    GError** error);
static void _vala_SoupURI_free (SoupURI* self);
GgitCred* gitg_credentials_manager_credentials (GitgCredentialsManager* self,
                                                const gchar* url,
                                                const gchar* username,
                                                GgitCredtype allowed_types,
                                                GError** error);
static void gitg_credentials_manager_finalize (GitgCredentialsManager * obj);
static void _vala_clear_GMutex (GMutex * mutex);
static void _vala_clear_GRecMutex (GRecMutex * mutex);
static void _vala_clear_GRWLock (GRWLock * mutex);
static void _vala_clear_GCond (GCond * mutex);

GQuark
gitg_credentials_error_quark (void)
{
	return g_quark_from_static_string ("gitg-credentials-error-quark");
}

static inline gpointer
gitg_credentials_manager_get_instance_private (GitgCredentialsManager* self)
{
	return G_STRUCT_MEMBER_P (self, GitgCredentialsManager_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

GitgCredentialsManager*
gitg_credentials_manager_construct (GType object_type,
                                    GgitConfig* config,
                                    GtkWindow* window,
                                    gboolean save_user_in_config)
{
	GitgCredentialsManager* self = NULL;
	GgitConfig* _tmp0_;
	GeeHashMap* _tmp1_;
	GtkWindow* _tmp2_;
	g_return_val_if_fail (window != NULL, NULL);
	self = (GitgCredentialsManager*) g_type_create_instance (object_type);
	_tmp0_ = _g_object_ref0 (config);
	_g_object_unref0 (self->priv->d_config);
	self->priv->d_config = _tmp0_;
	self->priv->d_save_user_in_config = save_user_in_config;
	_tmp1_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, ggit_credtype_get_type (), NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
	_g_object_unref0 (self->priv->d_auth_tried);
	self->priv->d_auth_tried = _tmp1_;
	_tmp2_ = _g_object_ref0 (window);
	_g_object_unref0 (self->priv->d_window);
	self->priv->d_window = _tmp2_;
	return self;
}

GitgCredentialsManager*
gitg_credentials_manager_new (GgitConfig* config,
                              GtkWindow* window,
                              gboolean save_user_in_config)
{
	return gitg_credentials_manager_construct (GITG_TYPE_CREDENTIALS_MANAGER, config, window, save_user_in_config);
}

static gint
_____lambda39_ (GitgCredentialsManager* self,
                GMatchInfo* info,
                const gchar* value)
{
	GeeHashMap* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gint result = 0;
	g_return_val_if_fail (info != NULL, 0);
	g_return_val_if_fail (value != NULL, 0);
	_tmp0_ = self->priv->d_usermap;
	_tmp1_ = g_match_info_fetch (info, 1);
	_tmp2_ = _tmp1_;
	gee_abstract_map_set ((GeeAbstractMap*) _tmp0_, _tmp2_, value);
	_g_free0 (_tmp2_);
	result = 0;
	return result;
}

static gint
______lambda39__ggit_config_match_callback (GMatchInfo* match_info,
                                            const gchar* value,
                                            gpointer self)
{
	gint result;
	result = _____lambda39_ ((GitgCredentialsManager*) self, match_info, value);
	return result;
}

static gchar*
gitg_credentials_manager_lookup_user (GitgCredentialsManager* self,
                                      const gchar* host)
{
	GeeHashMap* _tmp0_;
	GeeHashMap* _tmp11_;
	gpointer _tmp12_;
	GError* _inner_error0_ = NULL;
	gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (host != NULL, NULL);
	_tmp0_ = self->priv->d_usermap;
	if (_tmp0_ == NULL) {
		GeeHashMap* _tmp1_;
		GgitConfig* _tmp2_;
		_tmp1_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
		_g_object_unref0 (self->priv->d_usermap);
		self->priv->d_usermap = _tmp1_;
		_tmp2_ = self->priv->d_config;
		if (_tmp2_ != NULL) {
			{
				GRegex* r = NULL;
				GRegex* _tmp3_;
				GgitConfig* _tmp4_ = NULL;
				GgitConfig* _tmp5_;
				GgitConfig* _tmp6_;
				GRegex* _tmp7_;
				_tmp3_ = g_regex_new ("credential\\.(.*)\\.username", 0, 0, &_inner_error0_);
				r = _tmp3_;
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					goto __catch27_g_error;
				}
				_tmp5_ = self->priv->d_config;
				_tmp6_ = ggit_config_snapshot (_tmp5_, &_inner_error0_);
				_tmp4_ = _tmp6_;
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					_g_regex_unref0 (r);
					goto __catch27_g_error;
				}
				_tmp7_ = r;
				ggit_config_match_foreach (_tmp4_, _tmp7_, ______lambda39__ggit_config_match_callback, self, &_inner_error0_);
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					_g_object_unref0 (_tmp4_);
					_g_regex_unref0 (r);
					goto __catch27_g_error;
				}
				_g_object_unref0 (_tmp4_);
				_g_regex_unref0 (r);
			}
			goto __finally27;
			__catch27_g_error:
			{
				GError* e = NULL;
				FILE* _tmp8_;
				GError* _tmp9_;
				const gchar* _tmp10_;
				e = _inner_error0_;
				_inner_error0_ = NULL;
				_tmp8_ = stderr;
				_tmp9_ = e;
				_tmp10_ = _tmp9_->message;
				fprintf (_tmp8_, "Could not get username from git config: %s\n", _tmp10_);
				_g_error_free0 (e);
			}
			__finally27:
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return NULL;
			}
		}
	}
	_tmp11_ = self->priv->d_usermap;
	_tmp12_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp11_, host);
	result = (gchar*) _tmp12_;
	return result;
}

static Block5Data*
block5_data_ref (Block5Data* _data5_)
{
	g_atomic_int_inc (&_data5_->_ref_count_);
	return _data5_;
}

static void
block5_data_unref (void * _userdata_)
{
	Block5Data* _data5_;
	_data5_ = (Block5Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data5_->_ref_count_)) {
		GitgCredentialsManager* self;
		self = _data5_->self;
		_g_free0 (_data5_->newusername);
		_g_free0 (_data5_->password);
		_vala_clear_GCond (&_data5_->cond);
		_vala_clear_GMutex (&_data5_->mutex);
		_g_free0 (_data5_->url);
		_g_free0 (_data5_->username);
		_gitg_credentials_manager_unref0 (self);
		g_slice_free (Block5Data, _data5_);
	}
}

static gboolean
__lambda40_ (Block5Data* _data5_)
{
	GitgCredentialsManager* self;
	GgitCredtype tried = 0U;
	GeeHashMap* _tmp0_;
	gpointer _tmp1_;
	GitgAuthenticationDialog* d = NULL;
	GgitCredtype _tmp2_;
	GitgAuthenticationDialog* _tmp3_;
	GitgAuthenticationDialog* _tmp4_;
	GtkWindow* _tmp5_;
	GitgAuthenticationDialog* _tmp6_;
	GtkResponseType _tmp7_;
	GitgAuthenticationDialog* _tmp19_;
	gboolean result = FALSE;
	self = _data5_->self;
	_tmp0_ = self->priv->d_auth_tried;
	_tmp1_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp0_, _data5_->username);
	tried = ((GgitCredtype) ((gintptr) _tmp1_)) & (~GGIT_CREDTYPE_SSH_KEY);
	_tmp2_ = tried;
	_tmp3_ = gitg_authentication_dialog_new (_data5_->url, _data5_->username, _tmp2_ != 0);
	g_object_ref_sink (_tmp3_);
	d = _tmp3_;
	_tmp4_ = d;
	_tmp5_ = self->priv->d_window;
	gtk_window_set_transient_for ((GtkWindow*) _tmp4_, _tmp5_);
	_tmp6_ = d;
	_data5_->response = (GtkResponseType) gtk_dialog_run ((GtkDialog*) _tmp6_);
	_tmp7_ = _data5_->response;
	if (_tmp7_ == GTK_RESPONSE_OK) {
		GitgAuthenticationDialog* _tmp8_;
		const gchar* _tmp9_;
		const gchar* _tmp10_;
		gchar* _tmp11_;
		GitgAuthenticationDialog* _tmp12_;
		const gchar* _tmp13_;
		const gchar* _tmp14_;
		gchar* _tmp15_;
		GitgAuthenticationDialog* _tmp16_;
		GitgAuthenticationLifeTime _tmp17_;
		GitgAuthenticationLifeTime _tmp18_;
		_tmp8_ = d;
		_tmp9_ = gitg_authentication_dialog_get_username (_tmp8_);
		_tmp10_ = _tmp9_;
		_tmp11_ = g_strdup (_tmp10_);
		_g_free0 (_data5_->newusername);
		_data5_->newusername = _tmp11_;
		_tmp12_ = d;
		_tmp13_ = gitg_authentication_dialog_get_password (_tmp12_);
		_tmp14_ = _tmp13_;
		_tmp15_ = g_strdup (_tmp14_);
		_g_free0 (_data5_->password);
		_data5_->password = _tmp15_;
		_tmp16_ = d;
		_tmp17_ = gitg_authentication_dialog_get_life_time (_tmp16_);
		_tmp18_ = _tmp17_;
		_data5_->lifetime = _tmp18_;
	}
	_tmp19_ = d;
	gtk_widget_destroy ((GtkWidget*) _tmp19_);
	g_mutex_lock (&_data5_->mutex);
	g_cond_signal (&_data5_->cond);
	g_mutex_unlock (&_data5_->mutex);
	result = FALSE;
	_g_object_unref0 (d);
	return result;
}

static gboolean
___lambda40__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda40_ (self);
	return result;
}

static const gchar*
string_to_string (const gchar* self)
{
	const gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	result = self;
	return result;
}

static void
_g_free0_ (gpointer var)
{
	var = (g_free (var), NULL);
}

static gpointer
_g_hash_table_ref0 (gpointer self)
{
	return self ? g_hash_table_ref (self) : NULL;
}

static void
___lambda41_ (GitgCredentialsManager* self,
              GObject* obj,
              GAsyncResult* res)
{
	GError* _inner_error0_ = NULL;
	g_return_if_fail (res != NULL);
	{
		secret_password_store_finish (res, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch29_g_error;
		}
	}
	goto __finally29;
	__catch29_g_error:
	{
		GError* e = NULL;
		FILE* _tmp0_;
		GError* _tmp1_;
		const gchar* _tmp2_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp0_ = stderr;
		_tmp1_ = e;
		_tmp2_ = _tmp1_->message;
		fprintf (_tmp0_, "Failed to store secret in keyring: %s\n", _tmp2_);
		_g_error_free0 (e);
	}
	__finally29:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
}

static void
____lambda41__gasync_ready_callback (GObject* source_object,
                                     GAsyncResult* res,
                                     gpointer self)
{
	___lambda41_ ((GitgCredentialsManager*) self, source_object, res);
	gitg_credentials_manager_unref (self);
}

static void
___lambda42_ (GitgCredentialsManager* self,
              GObject* obj,
              GAsyncResult* res)
{
	GError* _inner_error0_ = NULL;
	g_return_if_fail (res != NULL);
	{
		secret_password_clear_finish (res, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch30_g_error;
		}
	}
	goto __finally30;
	__catch30_g_error:
	{
		GError* e = NULL;
		FILE* _tmp0_;
		GError* _tmp1_;
		const gchar* _tmp2_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp0_ = stderr;
		_tmp1_ = e;
		_tmp2_ = _tmp1_->message;
		fprintf (_tmp0_, "Failed to clear secret from keyring: %s\n", _tmp2_);
		_g_error_free0 (e);
	}
	__finally30:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
}

static void
____lambda42__gasync_ready_callback (GObject* source_object,
                                     GAsyncResult* res,
                                     gpointer self)
{
	___lambda42_ ((GitgCredentialsManager*) self, source_object, res);
	gitg_credentials_manager_unref (self);
}

static GgitCred*
gitg_credentials_manager_user_pass_dialog (GitgCredentialsManager* self,
                                           const gchar* url,
                                           const gchar* scheme,
                                           const gchar* host,
                                           const gchar* username,
                                           GError** error)
{
	Block5Data* _data5_;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	GtkResponseType _tmp4_;
	const gchar* _tmp6_;
	gchar* _tmp7_;
	gboolean _tmp8_ = FALSE;
	GHashTable* attributes = NULL;
	GHashFunc _tmp30_;
	GEqualFunc _tmp31_;
	GHashTable* _tmp32_;
	GHashTable* _tmp33_;
	gchar* _tmp34_;
	gchar* _tmp35_;
	GHashTable* _tmp36_;
	gchar* _tmp37_;
	gchar* _tmp38_;
	GHashTable* _tmp39_;
	gchar* _tmp40_;
	const gchar* _tmp41_;
	gchar* _tmp42_;
	GitgAuthenticationLifeTime _tmp43_;
	GeeHashMap* _tmp58_;
	const gchar* _tmp59_;
	GgitCredPlaintext* _tmp60_ = NULL;
	const gchar* _tmp61_;
	const gchar* _tmp62_;
	GgitCredPlaintext* _tmp63_;
	GgitCredPlaintext* _tmp64_;
	GError* _inner_error0_ = NULL;
	GgitCred* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (url != NULL, NULL);
	g_return_val_if_fail (scheme != NULL, NULL);
	g_return_val_if_fail (host != NULL, NULL);
	_data5_ = g_slice_new0 (Block5Data);
	_data5_->_ref_count_ = 1;
	_data5_->self = gitg_credentials_manager_ref (self);
	_tmp0_ = g_strdup (url);
	_g_free0 (_data5_->url);
	_data5_->url = _tmp0_;
	_tmp1_ = g_strdup (username);
	_g_free0 (_data5_->username);
	_data5_->username = _tmp1_;
	g_mutex_init (&_data5_->mutex);
	g_mutex_lock (&_data5_->mutex);
	g_cond_init (&_data5_->cond);
	_data5_->response = GTK_RESPONSE_CANCEL;
	_tmp2_ = g_strdup ("");
	_data5_->password = _tmp2_;
	_tmp3_ = g_strdup ("");
	_data5_->newusername = _tmp3_;
	_data5_->lifetime = GITG_AUTHENTICATION_LIFE_TIME_FORGET;
	g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ___lambda40__gsource_func, block5_data_ref (_data5_), block5_data_unref);
	g_cond_wait (&_data5_->cond, &_data5_->mutex);
	g_mutex_unlock (&_data5_->mutex);
	_tmp4_ = _data5_->response;
	if (_tmp4_ != GTK_RESPONSE_OK) {
		GError* _tmp5_;
		_tmp5_ = g_error_new_literal (GITG_CREDENTIALS_ERROR, GITG_CREDENTIALS_ERROR_CANCELLED, "cancelled by user");
		_inner_error0_ = _tmp5_;
		g_propagate_error (error, _inner_error0_);
		block5_data_unref (_data5_);
		_data5_ = NULL;
		return NULL;
	}
	_tmp6_ = _data5_->newusername;
	_tmp7_ = g_strdup (_tmp6_);
	_g_free0 (self->priv->d_last_user);
	self->priv->d_last_user = _tmp7_;
	if (_data5_->username == NULL) {
		_tmp8_ = TRUE;
	} else {
		gboolean _tmp9_ = FALSE;
		gboolean _tmp10_ = FALSE;
		const gchar* _tmp11_;
		_tmp11_ = _data5_->newusername;
		if (g_strcmp0 (_tmp11_, _data5_->username) != 0) {
			GgitConfig* _tmp12_;
			_tmp12_ = self->priv->d_config;
			_tmp10_ = _tmp12_ != NULL;
		} else {
			_tmp10_ = FALSE;
		}
		if (_tmp10_) {
			_tmp9_ = self->priv->d_save_user_in_config;
		} else {
			_tmp9_ = FALSE;
		}
		_tmp8_ = _tmp9_;
	}
	if (_tmp8_) {
		GeeHashMap* _tmp13_;
		_tmp13_ = self->priv->d_usermap;
		if (_tmp13_ == NULL) {
			GeeHashMap* _tmp14_;
			_tmp14_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
			_g_object_unref0 (self->priv->d_usermap);
			self->priv->d_usermap = _tmp14_;
		}
		{
			gchar* hid = NULL;
			const gchar* _tmp15_;
			const gchar* _tmp16_;
			gchar* _tmp17_;
			GgitConfig* _tmp18_;
			const gchar* _tmp19_;
			const gchar* _tmp20_;
			gchar* _tmp21_;
			gchar* _tmp22_;
			const gchar* _tmp23_;
			GeeHashMap* _tmp24_;
			const gchar* _tmp25_;
			const gchar* _tmp26_;
			_tmp15_ = string_to_string (scheme);
			_tmp16_ = string_to_string (host);
			_tmp17_ = g_strconcat (_tmp15_, "://", _tmp16_, NULL);
			hid = _tmp17_;
			_tmp18_ = self->priv->d_config;
			_tmp19_ = hid;
			_tmp20_ = string_to_string (_tmp19_);
			_tmp21_ = g_strconcat ("credential.", _tmp20_, ".username", NULL);
			_tmp22_ = _tmp21_;
			_tmp23_ = _data5_->newusername;
			ggit_config_set_string (_tmp18_, _tmp22_, _tmp23_, &_inner_error0_);
			_g_free0 (_tmp22_);
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				_g_free0 (hid);
				goto __catch28_g_error;
			}
			_tmp24_ = self->priv->d_usermap;
			_tmp25_ = hid;
			_tmp26_ = _data5_->newusername;
			gee_abstract_map_set ((GeeAbstractMap*) _tmp24_, _tmp25_, _tmp26_);
			_g_free0 (hid);
		}
		goto __finally28;
		__catch28_g_error:
		{
			GError* e = NULL;
			FILE* _tmp27_;
			GError* _tmp28_;
			const gchar* _tmp29_;
			e = _inner_error0_;
			_inner_error0_ = NULL;
			_tmp27_ = stderr;
			_tmp28_ = e;
			_tmp29_ = _tmp28_->message;
			fprintf (_tmp27_, "Failed to store username in config: %s\n", _tmp29_);
			_g_error_free0 (e);
		}
		__finally28:
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			g_propagate_error (error, _inner_error0_);
			block5_data_unref (_data5_);
			_data5_ = NULL;
			return NULL;
		}
	}
	_tmp30_ = g_str_hash;
	_tmp31_ = g_str_equal;
	_tmp32_ = g_hash_table_new_full (_tmp30_, _tmp31_, _g_free0_, _g_free0_);
	attributes = _tmp32_;
	_tmp33_ = attributes;
	_tmp34_ = g_strdup ("scheme");
	_tmp35_ = g_strdup (scheme);
	g_hash_table_insert (_tmp33_, _tmp34_, _tmp35_);
	_tmp36_ = attributes;
	_tmp37_ = g_strdup ("host");
	_tmp38_ = g_strdup (host);
	g_hash_table_insert (_tmp36_, _tmp37_, _tmp38_);
	_tmp39_ = attributes;
	_tmp40_ = g_strdup ("user");
	_tmp41_ = _data5_->newusername;
	_tmp42_ = g_strdup (_tmp41_);
	g_hash_table_insert (_tmp39_, _tmp40_, _tmp42_);
	_tmp43_ = _data5_->lifetime;
	if (_tmp43_ != GITG_AUTHENTICATION_LIFE_TIME_FORGET) {
		gchar* collection = NULL;
		GitgAuthenticationLifeTime _tmp44_;
		SecretSchema* _tmp46_;
		GHashTable* _tmp47_;
		GHashTable* _tmp48_;
		const gchar* _tmp49_;
		const gchar* _tmp50_;
		const gchar* _tmp51_;
		gchar* _tmp52_;
		gchar* _tmp53_;
		const gchar* _tmp54_;
		collection = NULL;
		_tmp44_ = _data5_->lifetime;
		if (_tmp44_ == GITG_AUTHENTICATION_LIFE_TIME_SESSION) {
			gchar* _tmp45_;
			_tmp45_ = g_strdup (SECRET_COLLECTION_SESSION);
			_g_free0 (collection);
			collection = _tmp45_;
		}
		_tmp46_ = gitg_credentials_manager_s_secret_schema;
		_tmp47_ = attributes;
		_tmp48_ = _g_hash_table_ref0 (_tmp47_);
		_tmp49_ = collection;
		_tmp50_ = string_to_string (scheme);
		_tmp51_ = string_to_string (host);
		_tmp52_ = g_strconcat (_tmp50_, "://", _tmp51_, NULL);
		_tmp53_ = _tmp52_;
		_tmp54_ = _data5_->password;
		secret_password_storev (_tmp46_, _tmp48_, _tmp49_, _tmp53_, _tmp54_, NULL, ____lambda41__gasync_ready_callback, gitg_credentials_manager_ref (self));
		_g_free0 (_tmp53_);
		_g_free0 (collection);
	} else {
		SecretSchema* _tmp55_;
		GHashTable* _tmp56_;
		GHashTable* _tmp57_;
		_tmp55_ = gitg_credentials_manager_s_secret_schema;
		_tmp56_ = attributes;
		_tmp57_ = _g_hash_table_ref0 (_tmp56_);
		secret_password_clearv (_tmp55_, _tmp57_, NULL, ____lambda42__gasync_ready_callback, gitg_credentials_manager_ref (self));
	}
	_tmp58_ = self->priv->d_auth_tried;
	_tmp59_ = _data5_->newusername;
	gee_abstract_map_set ((GeeAbstractMap*) _tmp58_, _tmp59_, (gpointer) ((gintptr) GGIT_CREDTYPE_USERPASS_PLAINTEXT));
	_tmp61_ = _data5_->newusername;
	_tmp62_ = _data5_->password;
	_tmp63_ = ggit_cred_plaintext_new (_tmp61_, _tmp62_, &_inner_error0_);
	_tmp60_ = _tmp63_;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_propagate_error (error, _inner_error0_);
		_g_hash_table_unref0 (attributes);
		block5_data_unref (_data5_);
		_data5_ = NULL;
		return NULL;
	}
	_tmp64_ = _tmp60_;
	_tmp60_ = NULL;
	result = (GgitCred*) _tmp64_;
	_g_object_unref0 (_tmp60_);
	_g_hash_table_unref0 (attributes);
	block5_data_unref (_data5_);
	_data5_ = NULL;
	return result;
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (needle != NULL, FALSE);
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
	result = _tmp0_ != NULL;
	return result;
}

static void
_vala_SoupURI_free (SoupURI* self)
{
	g_boxed_free (soup_uri_get_type (), self);
}

static GgitCred*
gitg_credentials_manager_query_user_pass (GitgCredentialsManager* self,
                                          const gchar* url,
                                          const gchar* username,
                                          GError** error)
{
	gchar* user = NULL;
	gchar* host = NULL;
	gchar* _tmp0_;
	gchar* scheme = NULL;
	gchar* _tmp1_;
	const gchar* _tmp31_;
	GError* _inner_error0_ = NULL;
	GgitCred* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (url != NULL, NULL);
	_tmp0_ = g_strdup ("local");
	host = _tmp0_;
	_tmp1_ = g_strdup ("file");
	scheme = _tmp1_;
	if (!string_contains (url, "://")) {
		GMatchInfo* minfo = NULL;
		GRegex* _tmp2_;
		GMatchInfo* _tmp3_ = NULL;
		gboolean _tmp4_;
		_tmp2_ = gitg_credentials_manager_s_ssh_short_form;
		_tmp4_ = g_regex_match (_tmp2_, url, 0, &_tmp3_);
		_g_match_info_unref0 (minfo);
		minfo = _tmp3_;
		if (_tmp4_) {
			gchar* _tmp5_;
			GMatchInfo* _tmp6_;
			gchar* _tmp7_;
			_tmp5_ = g_strdup ("ssh");
			_g_free0 (scheme);
			scheme = _tmp5_;
			_tmp6_ = minfo;
			_tmp7_ = g_match_info_fetch_named (_tmp6_, "host");
			_g_free0 (host);
			host = _tmp7_;
		}
		_g_match_info_unref0 (minfo);
	} else {
		SoupURI* uri = NULL;
		SoupURI* _tmp8_;
		SoupURI* _tmp9_;
		_tmp8_ = soup_uri_new (url);
		uri = _tmp8_;
		_tmp9_ = uri;
		if (_tmp9_ != NULL) {
			SoupURI* _tmp10_;
			const gchar* _tmp11_;
			gchar* _tmp12_;
			SoupURI* _tmp13_;
			SoupURI* _tmp20_;
			const gchar* _tmp21_;
			gchar* _tmp22_;
			_tmp10_ = uri;
			_tmp11_ = soup_uri_get_host (_tmp10_);
			_tmp12_ = g_strdup (_tmp11_);
			_g_free0 (host);
			host = _tmp12_;
			_tmp13_ = uri;
			if (!soup_uri_uses_default_port (_tmp13_)) {
				const gchar* _tmp14_;
				const gchar* _tmp15_;
				SoupURI* _tmp16_;
				gchar* _tmp17_;
				gchar* _tmp18_;
				gchar* _tmp19_;
				_tmp14_ = host;
				_tmp15_ = string_to_string (_tmp14_);
				_tmp16_ = uri;
				_tmp17_ = g_strdup_printf ("%u", soup_uri_get_port (_tmp16_));
				_tmp18_ = _tmp17_;
				_tmp19_ = g_strconcat (_tmp15_, ":", _tmp18_, NULL);
				_g_free0 (host);
				host = _tmp19_;
				_g_free0 (_tmp18_);
			}
			_tmp20_ = uri;
			_tmp21_ = soup_uri_get_scheme (_tmp20_);
			_tmp22_ = g_strdup (_tmp21_);
			_g_free0 (scheme);
			scheme = _tmp22_;
		}
		__vala_SoupURI_free0 (uri);
	}
	if (username == NULL) {
		const gchar* _tmp23_;
		const gchar* _tmp24_;
		const gchar* _tmp25_;
		const gchar* _tmp26_;
		gchar* _tmp27_;
		gchar* _tmp28_;
		gchar* _tmp29_;
		_tmp23_ = scheme;
		_tmp24_ = string_to_string (_tmp23_);
		_tmp25_ = host;
		_tmp26_ = string_to_string (_tmp25_);
		_tmp27_ = g_strconcat (_tmp24_, "://", _tmp26_, NULL);
		_tmp28_ = _tmp27_;
		_tmp29_ = gitg_credentials_manager_lookup_user (self, _tmp28_);
		_g_free0 (user);
		user = _tmp29_;
		_g_free0 (_tmp28_);
	} else {
		gchar* _tmp30_;
		_tmp30_ = g_strdup (username);
		_g_free0 (user);
		user = _tmp30_;
	}
	_tmp31_ = user;
	if (_tmp31_ != NULL) {
		GgitCredtype tried = 0U;
		GeeHashMap* _tmp32_;
		const gchar* _tmp33_;
		gpointer _tmp34_;
		GgitCredtype _tmp35_;
		_tmp32_ = self->priv->d_auth_tried;
		_tmp33_ = user;
		_tmp34_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp32_, _tmp33_);
		tried = (GgitCredtype) ((gintptr) _tmp34_);
		_tmp35_ = tried;
		if ((_tmp35_ & GGIT_CREDTYPE_USERPASS_PLAINTEXT) == 0) {
			gchar* secret = NULL;
			const gchar* _tmp43_;
			GeeHashMap* _tmp50_;
			const gchar* _tmp51_;
			secret = NULL;
			{
				gchar* _tmp36_ = NULL;
				SecretSchema* _tmp37_;
				const gchar* _tmp38_;
				const gchar* _tmp39_;
				const gchar* _tmp40_;
				gchar* _tmp41_;
				gchar* _tmp42_;
				_tmp37_ = gitg_credentials_manager_s_secret_schema;
				_tmp38_ = scheme;
				_tmp39_ = host;
				_tmp40_ = user;
				_tmp41_ = secret_password_lookup_sync (_tmp37_, NULL, &_inner_error0_, "scheme", _tmp38_, "host", _tmp39_, "user", _tmp40_, NULL);
				_tmp36_ = _tmp41_;
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					goto __catch31_g_error;
				}
				_tmp42_ = _tmp36_;
				_tmp36_ = NULL;
				_g_free0 (secret);
				secret = _tmp42_;
				_g_free0 (_tmp36_);
			}
			goto __finally31;
			__catch31_g_error:
			{
				g_clear_error (&_inner_error0_);
				_inner_error0_ = NULL;
			}
			__finally31:
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				g_propagate_error (error, _inner_error0_);
				_g_free0 (secret);
				_g_free0 (scheme);
				_g_free0 (host);
				_g_free0 (user);
				return NULL;
			}
			_tmp43_ = secret;
			if (_tmp43_ == NULL) {
				GgitCred* _tmp44_ = NULL;
				const gchar* _tmp45_;
				const gchar* _tmp46_;
				const gchar* _tmp47_;
				GgitCred* _tmp48_;
				GgitCred* _tmp49_;
				_tmp45_ = scheme;
				_tmp46_ = host;
				_tmp47_ = user;
				_tmp48_ = gitg_credentials_manager_user_pass_dialog (self, url, _tmp45_, _tmp46_, _tmp47_, &_inner_error0_);
				_tmp44_ = _tmp48_;
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					g_propagate_error (error, _inner_error0_);
					_g_free0 (secret);
					_g_free0 (scheme);
					_g_free0 (host);
					_g_free0 (user);
					return NULL;
				}
				_tmp49_ = _tmp44_;
				_tmp44_ = NULL;
				result = _tmp49_;
				_g_object_unref0 (_tmp44_);
				_g_free0 (secret);
				_g_free0 (scheme);
				_g_free0 (host);
				_g_free0 (user);
				return result;
			}
			_tmp50_ = self->priv->d_auth_tried;
			_tmp51_ = user;
			gee_abstract_map_set ((GeeAbstractMap*) _tmp50_, _tmp51_, (gpointer) ((gintptr) GGIT_CREDTYPE_USERPASS_PLAINTEXT));
			{
				GgitCredPlaintext* _tmp52_ = NULL;
				const gchar* _tmp53_;
				const gchar* _tmp54_;
				GgitCredPlaintext* _tmp55_;
				GgitCredPlaintext* _tmp56_;
				_tmp53_ = user;
				_tmp54_ = secret;
				_tmp55_ = ggit_cred_plaintext_new (_tmp53_, _tmp54_, &_inner_error0_);
				_tmp52_ = _tmp55_;
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					goto __catch32_g_error;
				}
				_tmp56_ = _tmp52_;
				_tmp52_ = NULL;
				result = (GgitCred*) _tmp56_;
				_g_object_unref0 (_tmp52_);
				_g_free0 (secret);
				_g_free0 (scheme);
				_g_free0 (host);
				_g_free0 (user);
				return result;
			}
			goto __finally32;
			__catch32_g_error:
			{
				GError* e = NULL;
				GgitCred* _tmp57_ = NULL;
				const gchar* _tmp58_;
				const gchar* _tmp59_;
				const gchar* _tmp60_;
				GgitCred* _tmp61_;
				GgitCred* _tmp62_;
				e = _inner_error0_;
				_inner_error0_ = NULL;
				_tmp58_ = scheme;
				_tmp59_ = host;
				_tmp60_ = user;
				_tmp61_ = gitg_credentials_manager_user_pass_dialog (self, url, _tmp58_, _tmp59_, _tmp60_, &_inner_error0_);
				_tmp57_ = _tmp61_;
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					_g_error_free0 (e);
					goto __finally32;
				}
				_tmp62_ = _tmp57_;
				_tmp57_ = NULL;
				result = _tmp62_;
				_g_object_unref0 (_tmp57_);
				_g_error_free0 (e);
				_g_free0 (secret);
				_g_free0 (scheme);
				_g_free0 (host);
				_g_free0 (user);
				return result;
			}
			__finally32:
			g_propagate_error (error, _inner_error0_);
			_g_free0 (secret);
			_g_free0 (scheme);
			_g_free0 (host);
			_g_free0 (user);
			return NULL;
		} else {
			GgitCred* _tmp63_ = NULL;
			const gchar* _tmp64_;
			const gchar* _tmp65_;
			const gchar* _tmp66_;
			GgitCred* _tmp67_;
			GgitCred* _tmp68_;
			_tmp64_ = scheme;
			_tmp65_ = host;
			_tmp66_ = user;
			_tmp67_ = gitg_credentials_manager_user_pass_dialog (self, url, _tmp64_, _tmp65_, _tmp66_, &_inner_error0_);
			_tmp63_ = _tmp67_;
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				g_propagate_error (error, _inner_error0_);
				_g_free0 (scheme);
				_g_free0 (host);
				_g_free0 (user);
				return NULL;
			}
			_tmp68_ = _tmp63_;
			_tmp63_ = NULL;
			result = _tmp68_;
			_g_object_unref0 (_tmp63_);
			_g_free0 (scheme);
			_g_free0 (host);
			_g_free0 (user);
			return result;
		}
	} else {
		GgitCred* _tmp69_ = NULL;
		const gchar* _tmp70_;
		const gchar* _tmp71_;
		const gchar* _tmp72_;
		GgitCred* _tmp73_;
		GgitCred* _tmp74_;
		_tmp70_ = scheme;
		_tmp71_ = host;
		_tmp72_ = user;
		_tmp73_ = gitg_credentials_manager_user_pass_dialog (self, url, _tmp70_, _tmp71_, _tmp72_, &_inner_error0_);
		_tmp69_ = _tmp73_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			g_propagate_error (error, _inner_error0_);
			_g_free0 (scheme);
			_g_free0 (host);
			_g_free0 (user);
			return NULL;
		}
		_tmp74_ = _tmp69_;
		_tmp69_ = NULL;
		result = _tmp74_;
		_g_object_unref0 (_tmp69_);
		_g_free0 (scheme);
		_g_free0 (host);
		_g_free0 (user);
		return result;
	}
	_g_free0 (scheme);
	_g_free0 (host);
	_g_free0 (user);
}

GgitCred*
gitg_credentials_manager_credentials (GitgCredentialsManager* self,
                                      const gchar* url,
                                      const gchar* username,
                                      GgitCredtype allowed_types,
                                      GError** error)
{
	const gchar* _tmp0_ = NULL;
	gchar* uslookup = NULL;
	gchar* _tmp1_;
	GgitCredtype tried = 0U;
	GeeHashMap* _tmp2_;
	const gchar* _tmp3_;
	gpointer _tmp4_;
	GgitCredtype untried_allowed_types = 0U;
	GgitCredtype _tmp5_;
	GgitCredtype _tmp6_;
	GError* _inner_error0_ = NULL;
	GgitCred* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (url != NULL, NULL);
	if (username != NULL) {
		_tmp0_ = username;
	} else {
		_tmp0_ = "";
	}
	_tmp1_ = g_strdup (_tmp0_);
	uslookup = _tmp1_;
	_tmp2_ = self->priv->d_auth_tried;
	_tmp3_ = uslookup;
	_tmp4_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp2_, _tmp3_);
	tried = (GgitCredtype) ((gintptr) _tmp4_);
	_tmp5_ = tried;
	untried_allowed_types = allowed_types & (~_tmp5_);
	_tmp6_ = untried_allowed_types;
	if ((_tmp6_ & GGIT_CREDTYPE_SSH_KEY) != 0) {
		GeeHashMap* _tmp7_;
		const gchar* _tmp8_;
		GgitCredtype _tmp9_;
		GgitCredSshKeyFromAgent* _tmp10_ = NULL;
		GgitCredSshKeyFromAgent* _tmp11_;
		GgitCredSshKeyFromAgent* _tmp12_;
		_tmp7_ = self->priv->d_auth_tried;
		_tmp8_ = uslookup;
		_tmp9_ = tried;
		gee_abstract_map_set ((GeeAbstractMap*) _tmp7_, _tmp8_, (gpointer) ((gintptr) (_tmp9_ | GGIT_CREDTYPE_SSH_KEY)));
		_tmp11_ = ggit_cred_ssh_key_from_agent_new (username, &_inner_error0_);
		_tmp10_ = _tmp11_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			g_propagate_error (error, _inner_error0_);
			_g_free0 (uslookup);
			return NULL;
		}
		_tmp12_ = _tmp10_;
		_tmp10_ = NULL;
		result = (GgitCred*) _tmp12_;
		_g_object_unref0 (_tmp10_);
		_g_free0 (uslookup);
		return result;
	} else {
		if ((allowed_types & GGIT_CREDTYPE_USERPASS_PLAINTEXT) != 0) {
			GgitCred* _tmp13_ = NULL;
			GgitCred* _tmp14_;
			GgitCred* _tmp15_;
			_tmp14_ = gitg_credentials_manager_query_user_pass (self, url, username, &_inner_error0_);
			_tmp13_ = _tmp14_;
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				g_propagate_error (error, _inner_error0_);
				_g_free0 (uslookup);
				return NULL;
			}
			_tmp15_ = _tmp13_;
			_tmp13_ = NULL;
			result = _tmp15_;
			_g_object_unref0 (_tmp13_);
			_g_free0 (uslookup);
			return result;
		}
	}
	result = NULL;
	_g_free0 (uslookup);
	return result;
}

static void
gitg_value_credentials_manager_init (GValue* value)
{
	value->data[0].v_pointer = NULL;
}

static void
gitg_value_credentials_manager_free_value (GValue* value)
{
	if (value->data[0].v_pointer) {
		gitg_credentials_manager_unref (value->data[0].v_pointer);
	}
}

static void
gitg_value_credentials_manager_copy_value (const GValue* src_value,
                                           GValue* dest_value)
{
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = gitg_credentials_manager_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}

static gpointer
gitg_value_credentials_manager_peek_pointer (const GValue* value)
{
	return value->data[0].v_pointer;
}

static gchar*
gitg_value_credentials_manager_collect_value (GValue* value,
                                              guint n_collect_values,
                                              GTypeCValue* collect_values,
                                              guint collect_flags)
{
	if (collect_values[0].v_pointer) {
		GitgCredentialsManager * object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = gitg_credentials_manager_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}

static gchar*
gitg_value_credentials_manager_lcopy_value (const GValue* value,
                                            guint n_collect_values,
                                            GTypeCValue* collect_values,
                                            guint collect_flags)
{
	GitgCredentialsManager ** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = gitg_credentials_manager_ref (value->data[0].v_pointer);
	}
	return NULL;
}

GParamSpec*
gitg_param_spec_credentials_manager (const gchar* name,
                                     const gchar* nick,
                                     const gchar* blurb,
                                     GType object_type,
                                     GParamFlags flags)
{
	GitgParamSpecCredentialsManager* spec;
	g_return_val_if_fail (g_type_is_a (object_type, GITG_TYPE_CREDENTIALS_MANAGER), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}

gpointer
gitg_value_get_credentials_manager (const GValue* value)
{
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GITG_TYPE_CREDENTIALS_MANAGER), NULL);
	return value->data[0].v_pointer;
}

void
gitg_value_set_credentials_manager (GValue* value,
                                    gpointer v_object)
{
	GitgCredentialsManager * old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GITG_TYPE_CREDENTIALS_MANAGER));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, GITG_TYPE_CREDENTIALS_MANAGER));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		gitg_credentials_manager_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		gitg_credentials_manager_unref (old);
	}
}

void
gitg_value_take_credentials_manager (GValue* value,
                                     gpointer v_object)
{
	GitgCredentialsManager * old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GITG_TYPE_CREDENTIALS_MANAGER));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, GITG_TYPE_CREDENTIALS_MANAGER));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		gitg_credentials_manager_unref (old);
	}
}

static void
gitg_credentials_manager_class_init (GitgCredentialsManagerClass * klass,
                                     gpointer klass_data)
{
	SecretSchema* _tmp0_;
	GError* _inner_error0_ = NULL;
	gitg_credentials_manager_parent_class = g_type_class_peek_parent (klass);
	((GitgCredentialsManagerClass *) klass)->finalize = gitg_credentials_manager_finalize;
	g_type_class_adjust_private_offset (klass, &GitgCredentialsManager_private_offset);
	_tmp0_ = secret_schema_new (APPLICATION_ID ".Credentials", SECRET_SCHEMA_NONE, "scheme", SECRET_SCHEMA_ATTRIBUTE_STRING, "host", SECRET_SCHEMA_ATTRIBUTE_STRING, "user", SECRET_SCHEMA_ATTRIBUTE_STRING, NULL);
	_secret_schema_unref0 (gitg_credentials_manager_s_secret_schema);
	gitg_credentials_manager_s_secret_schema = _tmp0_;
	{
		GRegex* _tmp1_ = NULL;
		GRegex* _tmp2_;
		GRegex* _tmp3_;
		_tmp2_ = g_regex_new ("^(?:[^: /@]+)@(?P<host>[^:]+)", 0, 0, &_inner_error0_);
		_tmp1_ = _tmp2_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch33_g_error;
		}
		_tmp3_ = _tmp1_;
		_tmp1_ = NULL;
		_g_regex_unref0 (gitg_credentials_manager_s_ssh_short_form);
		gitg_credentials_manager_s_ssh_short_form = _tmp3_;
		_g_regex_unref0 (_tmp1_);
	}
	goto __finally33;
	__catch33_g_error:
	{
		GError* e = NULL;
		FILE* _tmp4_;
		GError* _tmp5_;
		const gchar* _tmp6_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp4_ = stderr;
		_tmp5_ = e;
		_tmp6_ = _tmp5_->message;
		fprintf (_tmp4_, "regex err: %s\n", _tmp6_);
		_g_error_free0 (e);
	}
	__finally33:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
	}
}

static void
gitg_credentials_manager_instance_init (GitgCredentialsManager * self,
                                        gpointer klass)
{
	self->priv = gitg_credentials_manager_get_instance_private (self);
	self->ref_count = 1;
}

static void
gitg_credentials_manager_finalize (GitgCredentialsManager * obj)
{
	GitgCredentialsManager * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GITG_TYPE_CREDENTIALS_MANAGER, GitgCredentialsManager);
	g_signal_handlers_destroy (self);
	_g_object_unref0 (self->priv->d_config);
	_g_object_unref0 (self->priv->d_window);
	_g_object_unref0 (self->priv->d_usermap);
	_g_free0 (self->priv->d_last_user);
	_g_object_unref0 (self->priv->d_auth_tried);
}

GType
gitg_credentials_manager_get_type (void)
{
	static volatile gsize gitg_credentials_manager_type_id__volatile = 0;
	if (g_once_init_enter (&gitg_credentials_manager_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { gitg_value_credentials_manager_init, gitg_value_credentials_manager_free_value, gitg_value_credentials_manager_copy_value, gitg_value_credentials_manager_peek_pointer, "p", gitg_value_credentials_manager_collect_value, "p", gitg_value_credentials_manager_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (GitgCredentialsManagerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gitg_credentials_manager_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GitgCredentialsManager), 0, (GInstanceInitFunc) gitg_credentials_manager_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType gitg_credentials_manager_type_id;
		gitg_credentials_manager_type_id = g_type_register_fundamental (g_type_fundamental_next (), "GitgCredentialsManager", &g_define_type_info, &g_define_type_fundamental_info, 0);
		GitgCredentialsManager_private_offset = g_type_add_instance_private (gitg_credentials_manager_type_id, sizeof (GitgCredentialsManagerPrivate));
		g_once_init_leave (&gitg_credentials_manager_type_id__volatile, gitg_credentials_manager_type_id);
	}
	return gitg_credentials_manager_type_id__volatile;
}

gpointer
gitg_credentials_manager_ref (gpointer instance)
{
	GitgCredentialsManager * self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}

void
gitg_credentials_manager_unref (gpointer instance)
{
	GitgCredentialsManager * self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		GITG_CREDENTIALS_MANAGER_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}

static void
_vala_clear_GMutex (GMutex * mutex)
{
	GMutex zero_mutex = { 0 };
	if (memcmp (mutex, &zero_mutex, sizeof (GMutex))) {
		g_mutex_clear (mutex);
		memset (mutex, 0, sizeof (GMutex));
	}
}

static void
_vala_clear_GRecMutex (GRecMutex * mutex)
{
	GRecMutex zero_mutex = { 0 };
	if (memcmp (mutex, &zero_mutex, sizeof (GRecMutex))) {
		g_rec_mutex_clear (mutex);
		memset (mutex, 0, sizeof (GRecMutex));
	}
}

static void
_vala_clear_GRWLock (GRWLock * mutex)
{
	GRWLock zero_mutex = { 0 };
	if (memcmp (mutex, &zero_mutex, sizeof (GRWLock))) {
		g_rw_lock_clear (mutex);
		memset (mutex, 0, sizeof (GRWLock));
	}
}

static void
_vala_clear_GCond (GCond * mutex)
{
	GCond zero_mutex = { 0 };
	if (memcmp (mutex, &zero_mutex, sizeof (GCond))) {
		g_cond_clear (mutex);
		memset (mutex, 0, sizeof (GCond));
	}
}

